import unittest

from Python.library import APILibrary


class TestAPILibrary(unittest.TestCase):
    def test_init(self):
        adresse = 'google.com'
        c = APILibrary.api(adresse)
        self.assertEqual(c.adresse, adresse)
        self.assertEqual(c.header, {})

    def test_getoken(self):
        from Python import param
        adresse = 'https://accessadministrateuraitp.aneo.fr'
        c = APILibrary.api(adresse)
        endpoint = "api/auth-tokens"
        data = {'identifiant': param.login, 'motdepasse': param.motdepasse}
        retour = c.gettoken(endpoint, data)
        self.assertIsInstance(retour, str)

    def test_call(self):
        adresse = 'https://accessadministrateuraitp.aneo.fr'
        c = APILibrary.api(adresse)
        endpoint = "api/evenements"
        retour = c.call(endpoint, {}, APILibrary.method['GET'])
        self.assertEqual(retour.status_code, 200)
        self.assertEqual(retour.json()[0]['id'], 1)

    def test_callJson(self):
        adresse = 'https://accessadministrateuraitp.aneo.fr'
        c = APILibrary.api(adresse)
        endpoint = "api/evenements"
        retour = c.callJSON(endpoint, {}, APILibrary.method['GET'])
        self.assertEqual(retour[0]['id'], 1)
        self.assertEqual(retour[0]['titre'], 'Convention annuelle')


if __name__ == '__main__':
    unittest.main()
