import requests
from Python import param

try:
    # python 3
    from urllib.parse import urlencode
except ImportError:
    # python 2
    from urllib import urlencode
from io import BytesIO

method = {'GET': requests.get, 'POST': requests.post}

class api():
    def __init__(self, adresse):
        self.reponse = None
        self.adresse = adresse
        self.header = {}
        self.buffer = BytesIO()

    def call(self, endpoint, data, method):
        if param.isLogin:
            data = {'identifiant': param.login, 'motdepasse': param.motdepasse}
            self.token = self.gettoken(param.urllogin, data)
        else:
            self.token = param.token
        self.header = {'X-Auth-Token':self.token}
        self.reponse = method(self.adresse + '/' + endpoint, data=data, verify=False,headers=self.header)
        return self.reponse

    def callJSON(self,endpoint, data, method):
        return self.call(endpoint, data, method).json()

    def gettoken(self,endpoint, data):
        self.reponse = method['POST'](self.adresse + '/' + endpoint, data=data, verify=False)
        return self.reponse.json()['valeur']

